import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;

public class FileLogger extends AbstractLogger {
	PrintStream out;

	FileLogger(File f) {
		try {
			out=new PrintStream(f);
		} catch (FileNotFoundException fe) {
			fe.printStackTrace();
		}
	}

	FileLogger(String filename) {
		try {
			out=new PrintStream(filename);
		} catch (FileNotFoundException fe) {
			fe.printStackTrace();
		} 
	}

	public void logMessageImpl(String formattedmessage) {
		synchronized(out) {
			out.println(formattedmessage);
			out.flush(); /* File I/O needs to be flushed regularly. */
		}
	}
}
