import java.util.ArrayList;

public class Stack<T> {
	private ArrayList<T> list=new ArrayList<T>();

	/* Push */
	public void push(T t) {
		list.add(t);
	}

	/* Pop */ 
	public T pop() {
		T t;
		synchronized(list) {
			t=list.remove(size()-1);
		}
		return t;	
	}

	/* Count of elements */ 
	public int size() {
		return list.size();
	}
}
