public class StackTest {
	public static void main(String []args) throws InterruptedException {
		final Stack<Integer> is=new Stack<Integer>();

		Thread t1=new Thread( new Runnable() {
				public void run() {
					boolean done=false;
					while(!done) {
						Integer i;
						i=is.pop();
						if(i==null) System.err.println("Horribly Wrong!");
						else System.out.println("Pop: "+i);
						i=is.pop();
						if(i==null) System.err.println("Horribly Wrong!");
						else System.out.println("Pop: "+i);
						try {
							Thread.sleep(300);
						} catch(InterruptedException ie) {
							done=true;
						}
					}
				}
			} );
		Thread t2=new Thread( new Runnable() {
				public void run() {
					boolean done=false;
					while(!done) {
						Integer i;
						i=new Integer((int)(Math.random()*100));
						is.push(i);
						System.out.println("Push: "+i);
						i=new Integer((int)(Math.random()*100));
						is.push(i);
						System.out.println("Push: "+i);
						try {
							Thread.sleep(300);
						} catch(InterruptedException ie) {
							done=true;
						}
					}
				}
			} );
		t2.start();
		t1.start();
	}
}
