public class LoggerTest {
	public static void main(String []args) throws InterruptedException {
		final Logger l1=new DefaultLogger();
		final Logger l2=new FileLogger("log.txt");

		Thread t1=new Thread( new Runnable() {
				public void run() {
					boolean done=false;
					while(!done) {
						l1.logMessage(Logger.LOG_DEBUG,"This is I");
						l2.logMessage("This is I");
						l1.logMessage(Logger.LOG_INFO,"This is I");
						try {
							Thread.sleep(100);
						} catch(InterruptedException ie) {
							done=true;
						}
					}
				}
			} );
		Thread t2=new Thread( new Runnable() {
				public void run() {
					boolean done=false;
					while(!done) {
						l2.logMessage(Logger.LOG_DEBUG,"This is I");
						l1.logMessage("This is I");
						l2.logMessage(Logger.LOG_INFO,"This is I");
						try {
							Thread.sleep(100);
						} catch(InterruptedException ie) {
							done=true;
						}
					}
				}
			} );
		t1.start();
		t2.start();

		Thread.sleep(600);
		l1.setLogLevel(Logger.LOG_INFO);
		l1.logMessage("This isn't you");	
		l1.logMessage(Logger.LOG_ERROR,"This isn't you");	
		l1.setLogLevel(Logger.LOG_WARN);

		Thread.sleep(300);
		l2.setLogLevel(Logger.LOG_INFO);
		l2.logMessage("This isn't you");	
		l2.logMessage(Logger.LOG_ERROR,"This isn't you");	
		l2.setLogLevel(Logger.LOG_WARN);
	}
}
